// -*- mode:C++ ; compile-command: "g++ -I.. -g -c desolve.cc" -*-
/*
 *  Copyright (C) 2000 B. Parisse, Institut Fourier, 38402 St Martin d'Heres
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef _GIAC_DESOLVE_H
#define _GIAC_DESOLVE_H
#include "first.h"
#include "gen.h"
#include "identificateur.h"

#ifndef NO_NAMESPACE_GIAC
namespace giac {
#endif // ndef NO_NAMESPACE_GIAC

  gen laplace(const gen & f,const gen & x,const gen & s,GIAC_CONTEXT0);
  gen _laplace(const gen & args,GIAC_CONTEXT0);
  extern unary_function_ptr at_laplace ;

  gen ilaplace(const gen & f,const gen & x,const gen & s,GIAC_CONTEXT0);
  gen _ilaplace(const gen & args,GIAC_CONTEXT0);
  extern unary_function_ptr at_ilaplace ;

  gen desolve(const gen & f,const gen & x,const gen & y,int & ordre,vecteur & parameters,GIAC_CONTEXT0);
  gen _desolve(const gen & args,GIAC_CONTEXT0);
  extern unary_function_ptr at_desolve ;

#ifndef NO_NAMESPACE_GIAC
} // namespace giac
#endif // ndef NO_NAMESPACE_GIAC

#endif // _GIAC_DESOLVE_H
