// -*- mode:C++ ; compile-command: "g++ -I.. -g -c identificateur.cc" -*-
#include "first.h"
/*
 *  Copyright (C) 2000 B. Parisse, Institut Fourier, 38402 St Martin d'Heres
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
using namespace std;
#include <cmath>
#include <fstream>
//#include <unistd.h> // For reading arguments from file
#include "identificateur.h"
#include "gen.h"
#include "sym2poly.h"
#include "rpn.h"
#include "prog.h"
#ifdef WIN32
#include "usual.h"
#endif

#ifndef NO_NAMESPACE_GIAC
namespace giac {
#endif // ndef NO_NAMESPACE_GIAC

  // bool variables_are_files=true; // FIXME -> false and change rpn.cc at_VARS
  int protection_level=0; // for local variables

  string string_pi("pi");
  identificateur _IDNT_pi(string_pi,(double) M_PI);
  gen cst_pi(_IDNT_pi);
  string string_infinity("infinity");
  identificateur _IDNT_infinity(string_infinity);
  gen unsigned_inf(_IDNT_infinity);
  /*
#ifndef GNUWINCE
#ifdef WIN32
  gen cst_two_pi(symbolic(at_prod,makevecteur(2,cst_pi)));
  gen cst_pi_over_2(_FRAC2_SYMB(cst_pi,2));
  gen plus_inf(symbolic(at_plus,_IDNT_infinity));
  gen minus_inf(symbolic(at_neg,_IDNT_infinity));
#endif
#endif
  */
  string string_undef("undef");
  identificateur _IDNT_undef(string_undef);
  gen undef(_IDNT_undef);
  identificateur a__IDNT("a");
  gen a__IDNT_e(a__IDNT);
  identificateur b__IDNT("b");
  gen b__IDNT_e(b__IDNT);
  identificateur c__IDNT("c");
  gen c__IDNT_e(c__IDNT);
  identificateur d__IDNT("d");
  gen d__IDNT_e(d__IDNT);
  identificateur e__IDNT("e",(double) M_E);
  gen e__IDNT_e(e__IDNT);
  identificateur e__IDNT_("maple_e");
  gen e__IDNT_e_(e__IDNT_);
  identificateur f__IDNT("f");
  gen f__IDNT_e(f__IDNT);
  identificateur g__IDNT("g");
  gen g__IDNT_e(g__IDNT);
  identificateur h__IDNT("h");
  gen h__IDNT_e(h__IDNT);
  identificateur i__IDNT("i");
  gen i__IDNT_e(i__IDNT);
  identificateur I__IDNT("I");
  gen I__IDNT_e(I__IDNT);
  identificateur j__IDNT("j");
  gen j__IDNT_e(j__IDNT);
  identificateur k__IDNT("k");
  gen k__IDNT_e(k__IDNT);
  identificateur l__IDNT("l");
  gen l__IDNT_e(l__IDNT);
  identificateur m__IDNT("m");
  gen m__IDNT_e(m__IDNT);
  identificateur n__IDNT("n");
  gen n__IDNT_e(n__IDNT);
  identificateur o__IDNT("o");
  gen o__IDNT_e(o__IDNT);
  identificateur p__IDNT("p");
  gen p__IDNT_e(p__IDNT);
  identificateur q__IDNT("q");
  gen q__IDNT_e(q__IDNT);
  identificateur r__IDNT("r");
  gen r__IDNT_e(r__IDNT);
  identificateur s__IDNT("s");
  gen s__IDNT_e(s__IDNT);
  identificateur t__IDNT("t");
  gen t__IDNT_e(t__IDNT);
  identificateur u__IDNT("u");
  gen u__IDNT_e(u__IDNT);
  identificateur v__IDNT("v");
  gen v__IDNT_e(v__IDNT);
  identificateur w__IDNT("w");
  gen w__IDNT_e(w__IDNT);
  identificateur x__IDNT("x");
  gen x__IDNT_e(x__IDNT);
  gen vx_var(x__IDNT_e);
  identificateur y__IDNT("y");
  gen y__IDNT_e(y__IDNT);
  identificateur z__IDNT("z");
  gen z__IDNT_e(z__IDNT);
  identificateur CST__IDNT("CST");
  gen CST__IDNT_e(CST__IDNT);
  identificateur PICT__IDNT("PICT");
  gen PICT__IDNT_e(PICT__IDNT);
  gen tab_one_char__IDNT[]={a__IDNT_e,b__IDNT_e,c__IDNT_e,d__IDNT_e,e__IDNT_e,f__IDNT_e,g__IDNT_e,h__IDNT_e,i__IDNT_e,I__IDNT_e,j__IDNT_e,k__IDNT_e,l__IDNT_e,m__IDNT_e,n__IDNT_e,o__IDNT_e,p__IDNT_e,q__IDNT_e,r__IDNT_e,s__IDNT_e,t__IDNT_e,u__IDNT_e,v__IDNT_e,w__IDNT_e,x__IDNT_e,y__IDNT_e,z__IDNT_e,CST__IDNT_e,PICT__IDNT_e,zero};
  vecteur list_one_letter__IDNT(tab2vecteur(tab_one_char__IDNT));
  string string_break("break");
  identificateur _IDNT_break(string_break);
  string string_continue("continue");
  identificateur _IDNT_continue(string_continue);

  identificateur::identificateur(){
    ref_count = new int(1);
    value = NULL;
    quoted=new bool(false);
    localvalue = new vecteur;
    name = new string(" "+print_INT_(rand()));
  }

  identificateur::identificateur(const string & s){
    ref_count = new int(1);
    value = NULL;
    quoted=new bool(false);
    localvalue = new vecteur;
    name = new string(s);
  }

  identificateur::identificateur(const char * s){
    ref_count = new int(1);
    value = NULL;
    quoted=new bool(false);
    localvalue = new vecteur;
    name = new string(s);
  }

  identificateur::identificateur(const string & s,const gen & e){
    ref_count = new int(1);
    value = new gen(e);
    quoted=new bool(false);
    localvalue = new vecteur;
    name = new string(s);
  }

  identificateur::identificateur(const identificateur & s){
    ref_count=s.ref_count;
    if (ref_count){
      ++(*ref_count);
      value=s.value;
      quoted=s.quoted;
      localvalue=s.localvalue;
      name=s.name;
    }
  }

  identificateur::~identificateur(){
    if (ref_count){
      --(*ref_count);
      if (!(*ref_count)){
	delete ref_count;
	delete name;
        delete quoted;
	if (value)
	  delete value;
        delete localvalue;
      }
    }
  }

  identificateur & identificateur::operator =(const identificateur & s){
    if (ref_count){
      --(*ref_count);
      if (!(*ref_count)){
	delete ref_count;
	delete name;
	if (value)
	  delete value;
        delete localvalue;
      }
    }
    ref_count=s.ref_count;
    if (ref_count){
      ++(*ref_count);
      value=s.value;
      quoted=s.quoted;
      localvalue=s.localvalue;
      name=s.name;
    }
    return *this;
  }

  bool local_eval=true;
  // make g identificateurs evaluated as global
  gen global_eval(const gen & g,int level){
    if (g.type<_IDNT)
      return g;
    bool save_local_eval=local_eval;
    local_eval=false;
    gen tmp;
    try {
      tmp=g.eval(level);
    }
    catch (std::runtime_error & e){
      cerr << e.what() << endl;
    }
    local_eval=save_local_eval;
    if (tmp.type==_IDNT)
      tmp.subtype=_GLOBAL__EVAL;
    return tmp;
  }

  gen identificateur::eval(int level,const context * contextptr) {
    if (!ref_count)
      settypeerr();
    if (!level) 
      return gen(*this);
    if (contextptr){
      // check for global evaluation + quoted
      if (!contextptr->previous && contextptr->quoted_global_vars && equalposcomp(*contextptr->quoted_global_vars,*this)) 
	return *this;
      sym_tab::const_iterator it=contextptr->tabptr->find(*name),itend=contextptr->tabptr->end();
      if (it==itend){ // not found in current table
	if (contextptr->previous) // search in upper table
	  return eval(level,contextptr->previous);
	else
	  return *this;
      }
      else { // found, evaluate it in the global current context
	return it->second.eval(level-1,contextptr->globalcontextptr);
      }
    }
    if (local_eval && !localvalue->empty()){
      iterateur jtend=localvalue->end();
      if (protection_level>(jtend-2)->val)
	return global_eval(localvalue->back(),level-1);
      for (iterateur jt=localvalue->begin();;){
	if (jt==jtend)
	  break;
	--jtend;
	--jtend;
	if (protection_level>jtend->val){
	  ++jtend;
	  ++jtend;
	  break;
	}
      }
      localvalue->erase(jtend,localvalue->end());
      if (!localvalue->empty())
	return global_eval(localvalue->back(),level-1); // use global value in eval
    }
    if (*quoted )
      return gen(*this);
    if (current_folder_name.type==_IDNT && current_folder_name._IDNTptr->value && current_folder_name._IDNTptr->value->type==_VECT){
      gen res=find_in_folder(*current_folder_name._IDNTptr->value->_VECTptr,*this);
      if (res!=*this)
	return res;
    }
    if (value)
      return gen(value->eval(level-1));
    // look in current directory for a value
    if ( secure_run || (!variables_are_files(contextptr)) || (access((*name+cas_suffixe).c_str(),R_OK))){
      gen res=*this;
      if (!local_eval)
	res.subtype=_GLOBAL__EVAL;
      return res;
    }
    // set current value
    ifstream inf((*name+cas_suffixe).c_str());
    gen tmp(read1arg_from_stream(inf,list_one_letter__IDNT));
    if (child_id)
      return tmp;
    value = new gen(tmp);
    return gen(value->eval(level-1));
  }

  void identificateur::push(int protection,const gen & e){
      if (!localvalue)
          settypeerr();
      localvalue->push_back(protection);
      localvalue->push_back(e);
  }

  string identificateur::print () const{
    if (!ref_count)
      return string("null__IDNT");
    if (*this==_IDNT_pi){
      switch (maple_mode){
      case 1:
	return "Pi";
      case 2:
	return "PI";
      default:
	return string_pi;
      }
    }
    // index != sqrt(-1) wich has different notations
    if (maple_mode==0){
      if (*name=="i")
	return "_i";
    }
    else {
      if (*name=="I")
	return "_i";
    }
    /*
    if (!localvalue->empty())
      return string("_") + *name ;        
    if (value)
      return string("~") + *name ;
    else
    */
    int pos=name->find(' '),taille=name->size();
    if (pos<0 || pos>=taille)
      return *name  ;
    return '`'+*name+'`';
  }

  ostream & operator << (ostream & os,const identificateur & s) { return os << s.print();}

  int removecomments(const char * ss,char * ss2){
    int j=0,k=0;
    for (;ss[j];j++){
      if (ss[j]=='#'){
	ss2[k]=char(0); // end ss2 string
	break;
      }
      if (ss[j]>31){ // supress control chars
	ss2[k]=ss[j];
	k++;
      }
    }
    return k;
  }

  void identificateur::unassign(){
      if (value){
          delete(value);
          value = NULL;
      }
  }

#ifndef NO_NAMESPACE_GIAC
} // namespace giac
#endif // ndef NO_NAMESPACE_GIAC
